searchNodes=[{"doc":"Iona Document generation from Elixir, using LaTeX. Highlighted Features Generate professional-quality typeset .pdf (and .dvi ) documents using LaTeX , and support defining your own TeX processors for different formats. Built-in support for EEx templating with automatic escaping and a custom helpers Preprocessing support (multiple runs for bibliographies, etc) Optionally generating a prepared directory with a build.sh script for final processing. Prerequisites While features are on the roadmap to ease authorship of .tex documents, at the current time knowledge of LaTeX is assumed (or at least a basic willingness to wade into that very deep topic). We recommend you start your knowledge quest at the LaTeX homepage . Installation The package can be installed by adding iona to your list of dependencies in mix.exs : def deps do [ { :iona , &quot;~&gt; 0.4&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . The docs can be found at https://hexdocs.pm/iona . LaTeX Of course you need a TeX system installed, including latex , pdflatex , or any other variants you'd like to use to process your .tex source into final documents. (The default configuration assumes pdflatex is installed for PDF generation and latex is installed for DVI generation. See &quot;Configuration,&quot; below.) You can download and install a TeX system at the LaTeX Project website -- or using the the package management system of your choice. Examples From TeX source Generate a PDF from an existing .tex source: Iona . source ( path : &quot;simple.tex&quot; ) |&gt; Iona . write! ( &quot;/path/to/document.pdf&quot; ) You can also use a binary string: Iona . source ( &quot; \\d ocumentclass[12pt]{article} ...&quot; ) |&gt; Iona . write! ( &quot;/path/to/simple.pdf&quot; ) More complex preprocessing needs for citations and bibliographies? Define the prepocessing pipeline: Iona . source ( path : &quot;academic.tex&quot; ) |&gt; Iona . write! ( &quot;/path/to/academic.pdf&quot; , preprocess : ~w(latex bibtex latex) ) To generate a directory with a build script that can be run to finalize the build, use prepare : Iona . source ( path : &quot;academic.tex&quot; ) |&gt; Iona . prepare! ( &quot;/path/to/build/directory&quot; , :pdf , preprocess : ~w(latex bibtex latex) ) Want to get the raw document content as a binary? Use to : Iona . source ( path : &quot;fancy.tex&quot; ) |&gt; Iona . to ( :pdf ) |&gt; MyModule . do_something_with_pdf_string Complex preprocessors You can provide functions in the preprocessing pipeline too. The function will be invoked, given the temporary directory processing is occuring and the basename of the original file (eg, &quot;source.tex&quot; ): Iona . source ( path : &quot;source.tex&quot; ) |&gt; Iona . write! ( &quot;/path/to/source.pdf&quot; , preprocess : [ fn ( directory , filename ) -&gt; :ok end ] ) Function preprocessors should return: :ok if processing should continue {:shell, command} to indicate a command should be run as a preprocessor (see example below) {:error, reason} if processing should halt If given {:shell, command} , Iona will execute that command as a preprocessor. This is especially useful for interpolation, eg: knitr = fn ( _ , filename ) -&gt; { :shell , &quot;R -e &#39;library(knitr);knitr( \\&quot; \#{ filename } \\&quot; );&#39;&quot; } end Iona . source ( path : &quot;graphs.Rnw&quot; ) |&gt; Iona . write! ( &quot;/path/to/graphs.pdf&quot; , preprocess : [ knitr ] ) Important: As always, only interpolate trusted input into shell commands. From an EEx TeX template %{ title : &quot;My Document&quot; } |&gt; Iona . template! ( path : &quot;/path/to/template.tex.eex&quot; ) |&gt; Iona . write ( &quot;/path/to/my_document.pdf&quot; ) Values are inserted into EEx with, eg, &lt;%= @title %&gt; after being automatically escaped by Iona.Template.Helper.escape/1 . If you're confident values are safe for raw insertion into your LaTeX documents (or you'd like to support insertion of LaTeX commands), use raw/1 , made available by default as part of Iona.Template.Helper : For instance, if you wanted to style @title as boldface, you could pass it as &quot;{\\bf My Document}&quot; and insert it as a raw string: &lt; % = raw @title % &gt; With Custom Helpers You can import additional helper modules for use in your templates by two methods. The first (and preferred) method is by overriding the :helpers application configuration setting (see &quot;Configuration,&quot; below). You can also pass a :helpers option to Iona.template/2 with a list of additional helpers: %{ title : &quot;My Document&quot; } |&gt; Iona . template! ( path : &quot;/path/to/template.tex.eex&quot; , helpers : [ My.Custom.HelperModule ] ) |&gt; Iona . write ( &quot;/path/to/my_document.pdf&quot; ) Note in this case the setting is additive; the list is concatenated with the :helpers defined in the application configuration. Configuration The default, out-of-the-box settings for Iona are equivalent to the following Mix config: config :iona , helpers : [ Iona.Template.Helper ] , preprocess : [ ] , processors : [ pdf : &quot;pdflatex&quot; , dvi : &quot;latex&quot; ] Note you can also pass a :preprocess and :processor options to define a preprocessing pipeline on a case-by-case basis. See the examples above or the documentation for Iona.to/3 and Iona.write/3 . License See LICENSE . LaTeX LaTeX is free software, and is not distributed with this (unaffiliated) project. Please see the LaTeX homepage for more information.","ref":"Iona.html","title":"Iona","type":"module"},{"doc":"Generate a directory with a build script that can be run to finalize the build. Examples iex&gt; Iona . source ( path : &quot;academic.tex&quot; ) iex&gt; |&gt; Iona . prepare! ( &quot;/path/to/build/directory&quot; , :pdf , preprocess : ~w(latex bibtex latex) ) :ok","ref":"Iona.html#prepare/4","title":"Iona.prepare/4","type":"function"},{"doc":"The same as prepare/4 but raises Iona.ProcessingError if it fails.","ref":"Iona.html#prepare!/4","title":"Iona.prepare!/4","type":"function"},{"doc":"Define the document source, either as a raw TeX binary or the path to a .tex file. As raw TeX: Iona . source ( &quot; \\d ocumentclass[12pt]{article} ...&quot; ) From a file: Iona . source ( path : &quot;/path/to/document.tex&quot; ) When providing a file path, you can also define additional files needed for processing. They will be copied to the temporary directory where processing will take place. Iona . source ( path : &quot;/path/to/document.tex&quot; , include : [ &quot;/path/to/document.bib&quot; , &quot;/path/to/documentclass.sty&quot; ] ) However, when possible, files should be placed in the search path of your TeX installation.","ref":"Iona.html#source/1","title":"Iona.source/1","type":"function"},{"doc":"Fill in a template with assignments, with TeX escaping support { :ok , template } = [ title : &quot;An Article&quot; , author : &quot;Bruce Williams&quot; ] |&gt; Iona . template ( path : &quot;/path/to/article.tex&quot; ) Iona . write ( template , &quot;/path/to/article.pdf&quot; )","ref":"Iona.html#template/2","title":"Iona.template/2","type":"function"},{"doc":"The same as template/2 , but raises Iona.ProcessingError if it fails. Returns the template otherwise. [ title : &quot;An Article&quot; , author : &quot;Bruce Williams&quot; ] |&gt; Iona . template! ( path : &quot;/path/to/article.tex&quot; ) |&gt; Iona . write ( &quot;/path/to/article.pdf&quot; )","ref":"Iona.html#template!/2","title":"Iona.template!/2","type":"function"},{"doc":"Generate a formatted document as a string. Without processing options: { :ok , pdf_string } = Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . to ( :pdf ) With processing options: { :ok , pdf_string } = Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . to ( :pdf , processor : &quot;xetex&quot; )","ref":"Iona.html#to/3","title":"Iona.to/3","type":"function"},{"doc":"The same as to/3 , but raises Iona.ProcessingError if it fails. Returns the document content otherwise. Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . to! ( :pdf ) |&gt; MyModule . do_something_with_pdf_string If writing to a file, see write/3 and write/4 , as they are both shorter to type and have better performance characteristics.","ref":"Iona.html#to!/3","title":"Iona.to!/3","type":"function"},{"doc":"Generate a formatted document to a file path. Without processing options: :ok = Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . write ( &quot;/path/to/document.pdf&quot; ) With processing options: :ok = Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . write ( &quot;/path/to/document.pdf&quot; , processor : &quot;xetex&quot; )","ref":"Iona.html#write/3","title":"Iona.write/3","type":"function"},{"doc":"The same as write/3 but raises Iona.ProcessingError if it fails. Without processing options: Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . write! ( &quot;/path/to/document.pdf&quot; ) With processing options: Iona . source ( path : &quot;/path/to/document.tex&quot; ) |&gt; Iona . write! ( &quot;/path/to/document.pdf&quot; , processor : &quot;xetex&quot; )","ref":"Iona.html#write!/3","title":"Iona.write!/3","type":"function"},{"doc":"","ref":"Iona.html#t:eex_tex_t/0","title":"Iona.eex_tex_t/0","type":"type"},{"doc":"","ref":"Iona.html#t:executable_t/0","title":"Iona.executable_t/0","type":"type"},{"doc":"","ref":"Iona.html#t:processing_opts/0","title":"Iona.processing_opts/0","type":"type"},{"doc":"","ref":"Iona.html#t:source_opts/0","title":"Iona.source_opts/0","type":"type"},{"doc":"","ref":"Iona.html#t:supported_format_t/0","title":"Iona.supported_format_t/0","type":"type"},{"doc":"","ref":"Iona.html#t:template_opts/0","title":"Iona.template_opts/0","type":"type"},{"doc":"","ref":"Iona.html#t:tex_t/0","title":"Iona.tex_t/0","type":"type"},{"doc":"","ref":"Iona.Input.html","title":"Iona.Input","type":"protocol"},{"doc":"","ref":"Iona.Input.html#content/1","title":"Iona.Input.content/1","type":"function"},{"doc":"","ref":"Iona.Input.html#included_files/1","title":"Iona.Input.included_files/1","type":"function"},{"doc":"","ref":"Iona.Input.html#path/1","title":"Iona.Input.path/1","type":"function"},{"doc":"","ref":"Iona.Input.html#path?/1","title":"Iona.Input.path?/1","type":"function"},{"doc":"","ref":"Iona.Input.html#t:t/0","title":"Iona.Input.t/0","type":"type"},{"doc":"Provides basic template helper functions. The most important function is escape , which is automatically applied to any value in a &lt;%= %&gt; concat tag.","ref":"Iona.Template.Helper.html","title":"Iona.Template.Helper","type":"module"},{"doc":"Escape raw LaTeX commands and reserved characters, to include: Angle brackets and curly braces Backslashes Carets Tildes Pipes More! (See the @replace module attribute)","ref":"Iona.Template.Helper.html#escape/1","title":"Iona.Template.Helper.escape/1","type":"function"},{"doc":"","ref":"Iona.Template.Helper.html#escape_to_iodata/1","title":"Iona.Template.Helper.escape_to_iodata/1","type":"function"},{"doc":"Mark text as a string to be inserted raw and unescaped","ref":"Iona.Template.Helper.html#raw/1","title":"Iona.Template.Helper.raw/1","type":"function"},{"doc":"Defines the LaTex safe protocol. In order to promote LaTex safety, Phoenix templates do not use Kernel.to_string/1 to convert data types to strings in templates. Instead, Phoenix uses this protocol which must be implemented by data structures and guarantee that a LaTex safe representation is returned. Furthermore, this protocol relies on iodata, which provides better performance when sending or streaming data to the client.","ref":"Iona.Template.Safe.html","title":"Iona.Template.Safe","type":"protocol"},{"doc":"","ref":"Iona.Template.Safe.html#to_iodata/1","title":"Iona.Template.Safe.to_iodata/1","type":"function"},{"doc":"","ref":"Iona.Template.Safe.html#t:t/0","title":"Iona.Template.Safe.t/0","type":"type"},{"doc":"","ref":"Iona.Processing.ProcessingError.html","title":"Iona.Processing.ProcessingError","type":"exception"},{"doc":"","ref":"Iona.Processing.UnsupportedFormatError.html","title":"Iona.Processing.UnsupportedFormatError","type":"exception"}]